﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TM_S9000Sample
{
    public partial class ConfigureForm : Form
    {
        private StructByStep m_objConfigData = null;

        public ConfigureForm()
        {
            InitializeComponent();

            m_objConfigData = new StructByStep();
        }

        private void ConfigureForm_Load(object sender, EventArgs e)
        {
            LoadResourceString();

            SetControlData();

            UpdateControls();
        }

        public void SetConfigData(StructByStep objConfigData)
        {
            m_objConfigData.Copy(objConfigData);
        }

        public void GetConfigData(ref StructByStep objConfigData)
        {
            if (objConfigData != null)
            {
                objConfigData.Copy(m_objConfigData);
            }
        }

        private void LoadResourceString()
        {
            ////////////////
            //// Step 2 ////
            ////////////////

            btnOK.Text                  = ConstComStr.STR_CONFIGDLG_BUTTON_OK;
            btnCancel.Text              = ConstComStr.STR_CONFIGDLG_BUTTON_CANCEL;

            stGroupScanning.Text        = ConstComStr.STR_CONFIGDLG_GROUP_SCANNING;
            stGroupScanningMedia.Text   = ConstComStr.STR_CONFIGDLG_GROUP_SCANNINGMEDIA;
            stGroupImageChannel.Text    = ConstComStr.STR_CONFIGDLG_GROUP_IMAGECHANNEL;
            stGroupRGBColorDepth.Text   = ConstComStr.STR_CONFIGDLG_GROUP_RGBCOLORDEPTH;
            stGroupIRColorDepth.Text    = ConstComStr.STR_CONFIGDLG_GROUP_IRCOLORDEPTH;

            stResolution.Text           = ConstComStr.STR_CONFIGDLG_STATIC_RESOLUTION;

            btnRadioSMCheckPaper.Text   = ConstComStr.STR_CONFIGDLG_RADIO_SM_CHECKPAPER;
            btnRadioSMCard.Text         = ConstComStr.STR_CONFIGDLG_RADIO_SM_CARD;
            btnRadioICRGB.Text          = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGB;
            btnRadioICIR.Text           = ConstComStr.STR_CONFIGDLG_RADIO_IC_IR;
            btnRadioICRGBIR.Text        = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGBIR;
            btnRadioCDRColor.Text       = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_COLOR;
            btnRadioCDRGray.Text        = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_GRAY;
            btnRadioCDRBW.Text          = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_BW;
            btnRadioCDIGray.Text        = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_GRAY;
            btnRadioCDIBW.Text          = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_BW;
            btnCheckSCSave.Text         = ConstComStr.STR_CONFIGDLG_CHECK_SC_SAVEFILE;

            cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600);
            cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300);
            cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240);
            cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200);
            cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120);
            cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100);


            ////////////////
            //// Step 3 ////
            ////////////////

            stGroupMICR.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICR;
            stGroupMICRFont.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICRFONT;

            btnRadioMFE13B.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_E13B;
            btnRadioMFCMC7.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_CMC7;

            btnCheckMIClearSpace.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_CLEARSPACE;
            btnCheckMISaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_SAVEFILE;


            ////////////////
            //// Step 5 ////
            ////////////////

            stGroupPrinting.Text    = ConstComStr.STR_CONFIGDLG_GROUP_PRINT;
            stPrintStation.Text     = ConstComStr.STR_CONFIGDLG_STATIC_PRINTSTATION;
            stPrintingNumber.Text   = ConstComStr.STR_CONFIGDLG_STATIC_PRINTNUMBER;
            btnCheckScanning.Text   = ConstComStr.STR_CONFIGDLG_CHECK_PR_SCANNING;

            cmbPrintStation.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_PS_PRINTRECEIPT);
            cmbPrintStation.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_PS_PRINTCASHIERSCHECK);
			// S9000 only
			if (m_objConfigData.bIsRollPaperSupported)
			{
				cmbPrintStation.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_PS_PRINTROLLPAPER);
			}
        }

        private void SetControlData()
        {
            ////////////////
            //// Step 2 ////
            ////////////////
            switch (m_objConfigData.nRadio_ScanningMedia)
            {
                case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER:
                    btnRadioSMCheckPaper.Checked    = true;
                    btnRadioSMCard.Checked          = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD:
                    btnRadioSMCheckPaper.Checked    = false;
                    btnRadioSMCard.Checked          = true;
                    break;
                default:
                    break;
            }
            switch (m_objConfigData.nRadio_ImageChannel)
            {
                case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB:
                    btnRadioICRGB.Checked           = true;
                    btnRadioICIR.Checked            = false;
                    btnRadioICRGBIR.Checked         = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR:
                    btnRadioICRGB.Checked           = false;
                    btnRadioICIR.Checked            = true;
                    btnRadioICRGBIR.Checked         = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR:
                    btnRadioICRGB.Checked           = false;
                    btnRadioICIR.Checked            = false;
                    btnRadioICRGBIR.Checked         = true;
                    break;
                default:
                    break;
            }
            switch (m_objConfigData.nRadio_RGBColorDepth)
            {
                case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR:
                    btnRadioCDRColor.Checked        = true;
                    btnRadioCDRGray.Checked         = false;
                    btnRadioCDRBW.Checked           = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY:
                    btnRadioCDRColor.Checked        = false;
                    btnRadioCDRGray.Checked         = true;
                    btnRadioCDRBW.Checked           = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW:
                    btnRadioCDRColor.Checked        = false;
                    btnRadioCDRGray.Checked         = false;
                    btnRadioCDRBW.Checked           = true;
                    break;
                default:
                    break;
            }
            switch (m_objConfigData.nRadio_IRColorDepth)
            {
                case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY:
                    btnRadioCDIGray.Checked         = true;
                    btnRadioCDIBW.Checked           = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW:
                    btnRadioCDIGray.Checked         = false;
                    btnRadioCDIBW.Checked           = true;
                    break;
                default:
                    break;
            }

            btnCheckSCSave.Checked      = m_objConfigData.bCheck_Scan_SaveFile;
            cmbResolution.SelectedIndex = m_objConfigData.nCombo_Resolution;


            ////////////////
            //// Step 3 ////
            ////////////////
            switch (m_objConfigData.nRadio_MICRFont)
            {
                case ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B:
                    btnRadioMFE13B.Checked          = true;
                    btnRadioMFCMC7.Checked          = false;
                    break;
                case ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7:
                    btnRadioMFE13B.Checked          = false;
                    btnRadioMFCMC7.Checked          = true;
                    break;
                default:
                    break;
            }

            btnCheckMIClearSpace.Checked    = m_objConfigData.bCheck_MICR_ClearSpace;
            btnCheckMISaveFile.Checked      = m_objConfigData.bCheck_MICR_SaveFile;


            ////////////////
            //// Step 5 ////
            ////////////////
            cmbPrintStation.SelectedIndex   = m_objConfigData.nCombo_PrintStation;
            btnCheckScanning.Checked        = m_objConfigData.bCheck_Print_Scanning;
            udPrintingNumber.Minimum        = 0;
            udPrintingNumber.Maximum        = 255;
            udPrintingNumber.Value          = Convert.ToDecimal(m_objConfigData.byNumeric_Ptinting_Number);

        }
        
        private void GetControlData()
        {
	        ////////////////
	        //// Step 2 ////
	        ////////////////
	        if( btnRadioSMCheckPaper.Checked == true )
	        {
		        m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
	        }
	        else if( btnRadioSMCard.Checked == true )
	        {
		        m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD;
	        }

	        if( btnRadioICRGB.Checked == true )
	        {
		        m_objConfigData.nRadio_ImageChannel = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB;
	        }
	        else if( btnRadioICIR.Checked == true )
	        {
		        m_objConfigData.nRadio_ImageChannel = ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR;
	        }
	        else if( btnRadioICRGBIR.Checked == true )
	        {
		        m_objConfigData.nRadio_ImageChannel = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR;
	        }

	        if( btnRadioCDRColor.Checked == true )
	        {
		        m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
	        }
	        else if( btnRadioCDRGray.Checked == true )
	        {
		        m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY;
	        }
	        else if( btnRadioCDRBW.Checked == true )
	        {
		        m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW;
	        }

	        if( btnRadioCDIGray.Checked == true )
	        {
		        m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY;
	        }
	        else if( btnRadioCDIBW.Checked == true )
	        {
		        m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW;
	        }

	        m_objConfigData.bCheck_Scan_SaveFile    = btnCheckSCSave.Checked;
	        m_objConfigData.nCombo_Resolution       = GetValueResolutionCombobox();

	        ////////////////
	        //// Step 3 ////
	        ////////////////
	        if( btnRadioMFE13B.Checked == true )
	        {
		        m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B;
	        }
	        else if( btnRadioMFCMC7.Checked == true )
	        {
		        m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7;
	        }

            m_objConfigData.bCheck_MICR_ClearSpace  = btnCheckMIClearSpace.Checked;
            m_objConfigData.bCheck_MICR_SaveFile    = btnCheckMISaveFile.Checked;

            ////////////////
            //// Step 5 ////
            ////////////////
            m_objConfigData.nCombo_PrintStation         = GetValuePrintStationCombobox();
            m_objConfigData.bCheck_Print_Scanning       = btnCheckScanning.Checked;
            m_objConfigData.byNumeric_Ptinting_Number   = Convert.ToByte(udPrintingNumber.Value);
        }

        private void UpdateControls()
        {
	        ////////////////
	        //// Step 2 ////
            ////////////////

            // ImageChannel
            if (btnRadioSMCard.Checked == true)
            {
                btnRadioICRGBIR.Enabled = false;

                if (btnRadioICRGBIR.Checked == true)
                {
                    btnRadioICIR.Checked = true;
                    btnRadioICRGBIR.Checked = false;
                }

            }
            else if (btnRadioSMCheckPaper.Checked == true)
            {
                btnRadioICRGBIR.Enabled = true;
            }

	        // RGB ColorDepth Color
	        if( btnRadioICIR.Checked == true )
	        {
		        btnRadioCDRColor.Enabled = false;
	        }
	        else
	        {
		        btnRadioCDRColor.Enabled = true;
	        }

	        // RGB ColorDepth Gray
	        if( btnRadioICIR.Checked == true )
	        {
		        btnRadioCDRGray.Enabled = false;
	        }
	        else
	        {
		        btnRadioCDRGray.Enabled = true;
	        }

	        // RGB ColorDepth B/W
	        if( btnRadioICIR.Checked == true || btnRadioSMCard.Checked == true )
	        {
		        btnRadioCDRBW.Enabled = false;
	        }
	        else
	        {
		        btnRadioCDRBW.Enabled = true;
	        }

	        // IR ColorDepth Gray
	        if( btnRadioICRGB.Checked == true )
	        {
		        btnRadioCDIGray.Enabled = false;
	        }
	        else
	        {
		        btnRadioCDIGray.Enabled = true;
	        }

	        // IR ColorDepth B/W
	        if( btnRadioICRGB.Checked == true || btnRadioSMCard.Checked == true )
	        {
		        btnRadioCDIBW.Enabled = false;
	        }
	        else
	        {
		        btnRadioCDIBW.Enabled = true;
	        }

            if (btnRadioCDRBW.Checked == true && btnRadioCDRGray.Enabled.Equals(true) && !btnRadioCDRBW.Enabled.Equals(true))
	        {
		        btnRadioCDRColor.Checked = false;
		        btnRadioCDRGray.Checked = true;
		        btnRadioCDRBW.Checked = false;
	        }
            if (btnRadioCDIBW.Checked == true && btnRadioCDIGray.Enabled.Equals(true) && !btnRadioCDIBW.Enabled.Equals(true))
	        {
		        btnRadioCDIGray.Checked = true;
		        btnRadioCDIBW.Checked = false;
	        }

            //  Updating resolution options for scanning unit
	        string strResolution;
            strResolution = cmbResolution.Text;
	        if( btnRadioSMCheckPaper.Checked == true )
	        {
		        cmbResolution.Items.Clear();
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300);
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240);
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200);
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120);
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100);
		        if( SetIndexResolutionCombobox( strResolution ) != true )
                {
                    // If selected option is disabled, 300*300 is set
                    cmbResolution.SelectedIndex = 0;
		        }
	        }
	        else if( btnRadioSMCard.Checked == true )
	        {
                cmbResolution.Items.Clear();
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600);
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300);
                cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200);
		        if( SetIndexResolutionCombobox( strResolution ) != true )
                {
                    // If selected option is disabled, 200*200 is set
                    cmbResolution.SelectedIndex = 2;
		        }
	        }

	        ////////////////
	        //// Step 3 ////
	        ////////////////

	        if( btnRadioSMCard.Checked == true )
	        {
		        btnRadioMFE13B.Enabled          = false;
		        btnRadioMFCMC7.Enabled          = false;
		        btnCheckMIClearSpace.Enabled    = false;
		        btnCheckMISaveFile.Enabled      = false;
	        }
	        else if( btnRadioSMCheckPaper.Checked == true )
	        {
		        btnRadioMFE13B.Enabled          = true;
		        btnRadioMFCMC7.Enabled          = true;
		        btnCheckMIClearSpace.Enabled    = true;
		        btnCheckMISaveFile.Enabled      = true;
	        }

            ////////////////
            //// Step 5 ////
            ////////////////

            int nPrintStation;
            nPrintStation = GetValuePrintStationCombobox();

            // Printing Number Checkbox
            if (nPrintStation == ConstComVal.VAL_CONFIGDLG_COMBO_PS_PRINTCASHIERSCHECK)
            {
                udPrintingNumber.Enabled = true;
            }
            else
            {
                udPrintingNumber.Enabled = false;
            }

            // Scanning Checkbox
            if (nPrintStation == ConstComVal.VAL_CONFIGDLG_COMBO_PS_PRINTCASHIERSCHECK)
            {
                btnCheckScanning.Enabled = true;
            }
            else
            {
                btnCheckScanning.Enabled = false;
            }

        }
        
        ////////////////
        //// Step 2 ////
        ////////////////

        private void btnOK_Click(object sender, EventArgs e)
        {
	        GetControlData();
            Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void OnChangeRadioScanningMedia(object sender, EventArgs e)
        {
	        UpdateControls();
        }

        private void OnChangeRadioImageChannel(object sender, EventArgs e)
        {
	        UpdateControls();
        }

        private bool SetIndexResolutionCombobox( string strResolution )
        {
            if (strResolution != null)
	        {
                if (cmbResolution.Items.Contains(strResolution) == true)
                {
                    cmbResolution.SelectedIndex = cmbResolution.Items.IndexOf(strResolution);
                    return true;
                }
                else
                {
                    cmbResolution.SelectedIndex = 0;
                    return false;
                }
	        }

            cmbResolution.SelectedIndex = 0;
	        return false;
        }

        private int GetValueResolutionCombobox()
        {
	        string strResolution;
            strResolution = cmbResolution.Text;

            if (strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600;
	        }
            if (strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300;
	        }
            if (strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240;
	        }
            if (strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200;
	        }
            if (strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120;
	        }
            if (strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100;
	        }

	        return -1;
        }

        ////////////////
        //// Step 3 ////
        ////////////////

        // None.
        
        ////////////////
        //// Step 5 ////
        ////////////////
        private void cmbPrintStation_SelectedIndexChanged(object sender, EventArgs e)
        {
	        UpdateControls();
        }

        private int GetValuePrintStationCombobox()
        {
	        string strPrintStation;
            strPrintStation = cmbPrintStation.Text;

            if (strPrintStation.Equals(ConstComStr.STR_CONFIGDLG_COMBO_PS_PRINTRECEIPT) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_PS_PRINTRECEIPT;
	        }
            if (strPrintStation.Equals(ConstComStr.STR_CONFIGDLG_COMBO_PS_PRINTCASHIERSCHECK) == true)
	        {
                return ConstComVal.VAL_CONFIGDLG_COMBO_PS_PRINTCASHIERSCHECK;
	        }
            if (strPrintStation.Equals(ConstComStr.STR_CONFIGDLG_COMBO_PS_PRINTROLLPAPER) == true)
	        {
                // S9000 only
                return ConstComVal.VAL_CONFIGDLG_COMBO_PS_PRINTROLLPAPER;
	        }

	        return -1;
        }
    }
}
