#if !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81)
#define SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81

#pragma once

// Step 1
#include "Scan.h"
#include "Micr.h"
#include "Option.h"

typedef int(__stdcall * PROCESS_ERROR_BACK_FUNC)(short);

class CApp
{
private:
	// Step 1
	CProperty_1								m_CCProperty;
	CScan									m_CCScan;
	CMicr									m_CCMicr;
	COption									m_CCOption;
	PROCESS_ERROR_BACK_FUNC					m_pFuncProcessErrorCB;

	DLL_BiOpenMonPrinter					BiOpenMonPrinter;
	DLL_BiCloseMonPrinter					BiCloseMonPrinter;
	DLL_BiSCNMICRSetStatusBackFunction		BiSCNMICRSetStatusBackFunction;
	DLL_BiSCNMICRCancelStatusBack			BiSCNMICRCancelStatusBack;
	DLL_BiCancelError						BiCancelError;
	DLL_BiGetStatus							BiGetStatus;

public:
	// Step 1
	CApp(void);
	virtual ~CApp(void);

	int		InitDevice(void);
	int		ExitDevice(void);
	int		CancelError(void);
	int		CancelScan(void);
	int		ScanCheck(void);
	int		GetDeviceStatus(LPDWORD lpStatus);
	void	SetProcessErrorCallback(PROCESS_ERROR_BACK_FUNC pProcessErrorCB);

private:
	// Step 1
	void		GetAPIProcAddress(void);
	static int	CALLBACK cbScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
	int			ScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
};

#endif  /* !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81) */
