#include "stdafx.h"
#include "Micr.h"

CMicr::CMicr(void)
{
	m_pCProperty = NULL;
}

CMicr::~CMicr(void)
{
}

int CMicr::Init(CProperty_1* pCCProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pCCProperty;

	GetAPIProcAddress();

	return nResult;
}

// Set MICR reading conditions
int CMicr::SetMicrSetting(void)
{
	int nResult = SUCCESS;
	BOOL bParsing = FALSE;
	BYTE byClearSpaces = CLEAR_SPACE_DISABLE;

	m_pCProperty->GetMfMicr()->iSize = sizeof(MF_MICR01);
	m_pCProperty->GetMfMicr()->iVersion = MF_MICR_VERSION01;

	nResult = BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfMicr(), MF_GET_MICR_DEFAULT);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfMicr()->bFont = m_pCProperty->GetFont();
	if(m_pCProperty->GetParsing())
	{
		bParsing = TRUE;
	}
	m_pCProperty->GetMfMicr()->blParsing = bParsing;

	nResult = BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfMicr(), MF_SET_MICR_PARAM);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	if(m_pCProperty->GetClearSpace())
	{
		byClearSpaces = CLEAR_SPACE_ENABLE;
	}
	nResult = BiMICRClearSpaces(m_pCProperty->GetHandle(), byClearSpaces);

	return nResult;
}

// Get MICR data
int CMicr::GetMicr(CMicrResult* pCCMicrResult)
{
	int nResult = SUCCESS;

	if(pCCMicrResult == NULL)
	{
		return -1;
	}

	nResult = BiGetMicrText(m_pCProperty->GetHandle(), m_pCProperty->GetTransactionNumber(), (MF_MICR*)m_pCProperty->GetMfMicr());
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pCCMicrResult->SetTransactionNumber(m_pCProperty->GetTransactionNumber());
	pCCMicrResult->SetResult(m_pCProperty->GetMfMicr()->iRet);
	pCCMicrResult->SetStatus(m_pCProperty->GetMfMicr()->bStatus);
	pCCMicrResult->SetDetail(m_pCProperty->GetMfMicr()->bDetail);
	pCCMicrResult->SetMicrStr(m_pCProperty->GetMfMicr()->szMicrStr);
	pCCMicrResult->SetAccountNumber(m_pCProperty->GetMfMicr()->szAccountNumber);
	pCCMicrResult->SetAmount(m_pCProperty->GetMfMicr()->szAmount);
	pCCMicrResult->SetBankNumber(m_pCProperty->GetMfMicr()->szBankNumber);
	pCCMicrResult->SetSerialNumber(m_pCProperty->GetMfMicr()->szSerialNumber);
	pCCMicrResult->SetEPC(m_pCProperty->GetMfMicr()->szEPC);
	pCCMicrResult->SetTransitNumber(m_pCProperty->GetMfMicr()->szTransitNumber);
	pCCMicrResult->SetCheckType(m_pCProperty->GetMfMicr()->lCheckType);
	pCCMicrResult->SetCountryCode(m_pCProperty->GetMfMicr()->lCountryCode);
	pCCMicrResult->SetOnUSField(m_pCProperty->GetMfMicr()->szOnUSField);
	pCCMicrResult->SetAuxiliatyOnUSField(m_pCProperty->GetMfMicr()->szAuxiliatyOnUsField);

	return nResult;
}


// MICR head cleaning
int CMicr::CleaningMicr(void)
{
	return BiMICRCleaning(m_pCProperty->GetHandle());
}

int CMicr::ClearMicrSetting(void)
{
	return BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfMicr(), MF_CLEAR_MICR_PARAM);
}

// Get functions of the API
void CMicr::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiSCNMICRFunctionContinuously	= (DLL_BiSCNMICRFunctionContinuously)	GetProcAddress(hLibrary, "BiSCNMICRFunctionContinuously");
	BiMICRClearSpaces				= (DLL_BiMICRClearSpaces)				GetProcAddress(hLibrary, "BiMICRClearSpaces");
	BiMICRCleaning					= (DLL_BiMICRCleaning)					GetProcAddress(hLibrary, "BiMICRCleaning");
	BiGetMicrText					= (DLL_BiGetMicrText)					GetProcAddress(hLibrary, "BiGetMicrText");
}
