// TM-S9000SampleDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "shlwapi.h"
//#include "DriverControl\\app.h"

// Callback from DriverControl
// Step 1
int CALLBACK CallbackFuncProcessError( short sErrorStatus );
// Step 2
int CALLBACK CallbackFuncImage(void);


// CTMS9000SampleDlg dialog
class CTMS9000SampleDlg : public CDialog
{
// Construction
public:
	CTMS9000SampleDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CTMS9000SampleDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_TMS9000SAMPLE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	virtual BOOL OnInitDialog(void);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint(void);
	afx_msg HCURSOR OnQueryDragIcon(void);
	DECLARE_MESSAGE_MAP()
	virtual BOOL DestroyWindow(void);
public:
	// Step 1
	afx_msg void OnBnClickedButtonScan(void);
	afx_msg void OnBnClickedButtonScanCancel(void);
	afx_msg void OnBnClickedButtonExit(void);
	// Step 2
	afx_msg void OnBnClickedButtonConfig(void);

// Control
protected:
	// Step 1
	CButton	m_btnScan;
	CButton	m_btnScanCancel;
	CButton	m_btnExit;

	// Step 2
	CStatic	m_stImage2Front;
	CStatic	m_stImage2Back;
	CStatic	m_stImage4RGBFront;
	CStatic	m_stImage4RGBBack;
	CStatic	m_stImage4IrFront;
	CStatic	m_stImage4IrBack;

	CButton	m_btnConfig;

// Processing after received callback from DriverControl
public:
	// Step 1
	void CallbackProcProcessError( short sErrorStatus );
	// Step 2
	void CallbackProcImage(void);

// Member Function
protected:
	// Step 1
	bool	InitializeDriver(void);
	int		TerminateDriver(void);
	void	ShowErrorMessage(int nResult );
	LPCTSTR GetErrorString(int nResultCode);
	void	LoadResourceString(void);
	// Step 2
	void	InitializeConfigData(void);
	void	ConvertScanParamToConfigData( CScanParam* pcScanParam, CONFIGDATA* psConfigData );
	void	ConvertConfigDataToScanParam( CONFIGDATA* psConfigData, CScanParam* pcScanParam );
	void	UpdateControls(void);
	void	UpdateImageData( BYTE byFace, BYTE byImage, HBITMAP* phBitmap );
	void	SaveImageData( BYTE byFace, BYTE byImage );
	void	DrawImage( HBITMAP hBitmap, CStatic* pstImage );
	void	ClearImage(void);
	bool	MakeFolder(CString & strFolderPath);

// Implementation
protected:
	HICON m_hIcon;
	bool m_bScanCancelError;

private:
	// Step 1
	CApp*	m_pcDriverControl;
	// Step 2
	CONFIGDATA	m_sConfigData;
	HBITMAP		m_hImage2Front;
	HBITMAP		m_hImage2Back;
	HBITMAP		m_hImage4RGBFront;
	HBITMAP		m_hImage4RGBBack;
	HBITMAP		m_hImage4IrFront;
	HBITMAP		m_hImage4IrBack;
};
