// ConfigureDlg.cpp : Implementation
//

#include "stdafx.h"
#include "Resource.h"
#include "ConfigureDlg.h"


// CConfigureDlg Dialog

IMPLEMENT_DYNAMIC(CConfigureDlg, CDialog)

CConfigureDlg::CConfigureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigureDlg::IDD, pParent)
{
}

CConfigureDlg::~CConfigureDlg(void)
{
}

void CConfigureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	// Step 2
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_GROUP_SCANNING, m_stGroupScanning);
	DDX_Control(pDX, IDC_GROUP_SCANNINGMEDIA, m_stGroupScanningMedia);
	DDX_Control(pDX, IDC_GROUP_IMAGECHANNEL, m_stGroupImageChannel);
	DDX_Control(pDX, IDC_GROUP_RGBCOLORDEPTH, m_stGroupRGBColorDepth);
	DDX_Control(pDX, IDC_GROUP_IRCOLORDEPTH, m_stGroupIRColorDepth);
	DDX_Control(pDX, IDC_STATIC_RESOLUTION, m_stResolution);
	DDX_Control(pDX, IDC_COMBO_RESOLUTION, m_cmbResolution);
	DDX_Control(pDX, IDC_RADIO_SM_CHECKPAPER, m_btnRadioSMCheckPaper);
	DDX_Control(pDX, IDC_RADIO_SM_CARD, m_btnRadioSMCard);
	DDX_Control(pDX, IDC_RADIO_IC_RGB, m_btnRadioICRGB);
	DDX_Control(pDX, IDC_RADIO_IC_IR, m_btnRadioICIR);
	DDX_Control(pDX, IDC_RADIO_IC_RGBIR, m_btnRadioICRGBIR);
	DDX_Control(pDX, IDC_RADIO_RGBCD_COLOR, m_btnRadioCDRColor);
	DDX_Control(pDX, IDC_RADIO_RGBCD_GRAY, m_btnRadioCDRGray);
	DDX_Control(pDX, IDC_RADIO_RGBCD_BW, m_btnRadioCDRBW);
	DDX_Control(pDX, IDC_RADIO_IRCD_GRAY, m_btnRadioCDIGray);
	DDX_Control(pDX, IDC_RADIO_IRCD_BW, m_btnRadioCDIBW);
	DDX_Control(pDX, IDC_CHECK_SC_SAVEFILE, m_btnCheckSCSave);
	// Step 3
	DDX_Control(pDX, IDC_GROUP_MICR, m_stGroupMICR);
	DDX_Control(pDX, IDC_GROUP_MICRFONT, m_stGroupMICRFont);
	DDX_Control(pDX, IDC_RADIO_MF_E13B, m_btnRadioMFE13B);
	DDX_Control(pDX, IDC_RADIO_MF_CMC7, m_btnRadioMFCMC7);
	DDX_Control(pDX, IDC_CHECK_MI_CLEARSPACE, m_btnCheckMIClearSpace);
	DDX_Control(pDX, IDC_CHECK_MI_SAVEFILE, m_btnCheckMISaveFile);
	// Step 4
	DDX_Control(pDX, IDC_GROUP_ENDORSEMENT, m_stGroupEndorsement);
	DDX_Control(pDX, IDC_GROUP_PRINTTYPE, m_stGroupPrintType);
	DDX_Control(pDX, IDC_GROUP_PRINTMODE, m_stGroupPrintMode);
	DDX_Control(pDX, IDC_RADIO_PT_PHYSICAL, m_btnRadioPTPhysical);
	DDX_Control(pDX, IDC_RADIO_PT_ELECTRONIC, m_btnRadioPTElectronic);
	DDX_Control(pDX, IDC_RADIO_PM_HIGHSPEEDMODE, m_btnRadioPMHighSpeedMode);
	DDX_Control(pDX, IDC_RADIO_PM_DATAWAITINGMODE, m_btnRadioPMDataWaitingMode);
	DDX_Control(pDX, IDC_CHECK_EN_PRINTTEXT, m_btnCheckENPrintText);
	DDX_Control(pDX, IDC_CHECK_EN_PRINTIMAGE, m_btnCheckENPrintImage);
	DDX_Control(pDX, IDC_CHECK_EN_PRNDATAUNRECEIVECANCEL, m_btnCheckENPrnDataUnreceiveCancel);
}


BEGIN_MESSAGE_MAP(CConfigureDlg, CDialog)
	// Step 2
	ON_BN_CLICKED(IDOK, &CConfigureDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CConfigureDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_RADIO_SM_CHECKPAPER, &CConfigureDlg::OnChangeRadioScanningMedia)
	ON_BN_CLICKED(IDC_RADIO_SM_CARD, &CConfigureDlg::OnChangeRadioScanningMedia)
	ON_BN_CLICKED(IDC_RADIO_IC_RGB, &CConfigureDlg::OnChangeRadioImageChannel)
	ON_BN_CLICKED(IDC_RADIO_IC_IR, &CConfigureDlg::OnChangeRadioImageChannel)
	ON_BN_CLICKED(IDC_RADIO_IC_RGBIR, &CConfigureDlg::OnChangeRadioImageChannel)
	// Step 4
	ON_BN_CLICKED(IDC_RADIO_PT_PHYSICAL, &CConfigureDlg::OnChangeRadioPrintType)
	ON_BN_CLICKED(IDC_RADIO_PT_ELECTRONIC, &CConfigureDlg::OnChangeRadioPrintType)
	ON_BN_CLICKED(IDC_RADIO_PM_HIGHSPEEDMODE, &CConfigureDlg::OnChangeRadioPrintMode)
	ON_BN_CLICKED(IDC_RADIO_PM_DATAWAITINGMODE, &CConfigureDlg::OnChangeRadioPrintMode)
END_MESSAGE_MAP()


// CConfigureDlg Message Handler
BOOL CConfigureDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	LoadResourceString();

	SetControlData();

	UpdateControls();

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CConfigureDlg::SetConfigData( CONFIGDATA sConfigData )
{
	m_sConfigData.Copy( sConfigData );
}

void CConfigureDlg::GetConfigData( LPCONFIGDATA psConfigData )
{
	if( psConfigData != NULL ){
		psConfigData->Copy( m_sConfigData );
	}
}

void CConfigureDlg::LoadResourceString(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	m_btnOK.SetWindowText( STR_CONFIGDLG_BUTTON_OK );
	m_btnCancel.SetWindowText( STR_CONFIGDLG_BUTTON_CANCEL );

	m_stGroupScanning.SetWindowText( STR_CONFIGDLG_GROUP_SCANNING );
	m_stGroupScanningMedia.SetWindowText( STR_CONFIGDLG_GROUP_SCANNINGMEDIA );
	m_stGroupImageChannel.SetWindowText( STR_CONFIGDLG_GROUP_IMAGECHANNEL );
	m_stGroupRGBColorDepth.SetWindowText( STR_CONFIGDLG_GROUP_RGBCOLORDEPTH );
	m_stGroupIRColorDepth.SetWindowText( STR_CONFIGDLG_GROUP_IRCOLORDEPTH );

	m_stResolution.SetWindowText( STR_CONFIGDLG_STATIC_RESOLUTION );

	m_btnRadioSMCheckPaper.SetWindowText( STR_CONFIGDLG_RADIO_SM_CHECKPAPER );
	m_btnRadioSMCard.SetWindowText( STR_CONFIGDLG_RADIO_SM_CARD );
	m_btnRadioICRGB.SetWindowText( STR_CONFIGDLG_RADIO_IC_RGB );
	m_btnRadioICIR.SetWindowText( STR_CONFIGDLG_RADIO_IC_IR );
	m_btnRadioICRGBIR.SetWindowText( STR_CONFIGDLG_RADIO_IC_RGBIR );
	m_btnRadioCDRColor.SetWindowText( STR_CONFIGDLG_RADIO_RGBCD_COLOR );
	m_btnRadioCDRGray.SetWindowText( STR_CONFIGDLG_RADIO_RGBCD_GRAY );
	m_btnRadioCDRBW.SetWindowText( STR_CONFIGDLG_RADIO_RGBCD_BW );
	m_btnRadioCDIGray.SetWindowText( STR_CONFIGDLG_RADIO_IRCD_GRAY );
	m_btnRadioCDIBW.SetWindowText( STR_CONFIGDLG_RADIO_IRCD_BW );
	m_btnCheckSCSave.SetWindowText( STR_CONFIGDLG_CHECK_SC_SAVEFILE );

	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_600600 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_300300 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_240240 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_200200 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_120120 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_100100 );

	////////////////
	//// Step 3 ////
	////////////////

	m_stGroupMICR.SetWindowText( STR_CONFIGDLG_GROUP_MICR );
	m_stGroupMICRFont.SetWindowText( STR_CONFIGDLG_GROUP_MICRFONT );

	m_btnRadioMFE13B.SetWindowText( STR_CONFIGDLG_RADIO_MF_E13B );
	m_btnRadioMFCMC7.SetWindowText( STR_CONFIGDLG_RADIO_MF_CMC7 );

	m_btnCheckMIClearSpace.SetWindowText( STR_CONFIGDLG_CHECK_MI_CLEARSPACE );
	m_btnCheckMISaveFile.SetWindowText( STR_CONFIGDLG_CHECK_MI_SAVEFILE );

	////////////////
	//// Step 4 ////
	////////////////

	m_stGroupEndorsement.SetWindowText( STR_CONFIGDLG_GROUP_ENDORSEMENT );
	m_stGroupPrintType.SetWindowText( STR_CONFIGDLG_GROUP_PRINTTYPE );
	m_stGroupPrintMode.SetWindowText( STR_CONFIGDLG_GROUP_PRINTMODE );

	m_btnRadioPTPhysical.SetWindowText( STR_CONFIGDLG_RADIO_PT_PHYSICAL );
	m_btnRadioPTElectronic.SetWindowText( STR_CONFIGDLG_RADIO_PT_ELECTRONIC );
	m_btnRadioPMHighSpeedMode.SetWindowText( STR_CONFIGDLG_RADIO_PT_HIGHSPEEDMODE );
	m_btnRadioPMDataWaitingMode.SetWindowText( STR_CONFIGDLG_RADIO_PT_DATAWAITINGMODE );

	m_btnCheckENPrintText.SetWindowText( STR_CONFIGDLG_CHECK_EN_PRINTTEXT );
	m_btnCheckENPrintImage.SetWindowText( STR_CONFIGDLG_CHECK_EN_PRINTIMAGE );
	m_btnCheckENPrnDataUnreceiveCancel.SetWindowText( STR_CONFIGDLG_CHECK_EN_PRNDATAUNRECEIVECANCEL );
}

void CConfigureDlg::SetControlData(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	switch( m_sConfigData.nRadio_ScanningMedia )
	{
		case VAL_CONFIGDLG_RADIO_SM_CHECKPAPER:
			m_btnRadioSMCheckPaper.SetCheck(1);
			m_btnRadioSMCard.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_SM_CARD:
			m_btnRadioSMCheckPaper.SetCheck(0);
			m_btnRadioSMCard.SetCheck(1);
			break;
		default:
			break;
	}
	switch( m_sConfigData.nRadio_ImageChannel )
	{
		case VAL_CONFIGDLG_RADIO_IC_RGB:
			m_btnRadioICRGB.SetCheck(1);
			m_btnRadioICIR.SetCheck(0);
			m_btnRadioICRGBIR.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_IC_IR:
			m_btnRadioICRGB.SetCheck(0);
			m_btnRadioICIR.SetCheck(1);
			m_btnRadioICRGBIR.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_IC_RGBIR:
			m_btnRadioICRGB.SetCheck(0);
			m_btnRadioICIR.SetCheck(0);
			m_btnRadioICRGBIR.SetCheck(1);
			break;
		default:
			break;
	}
	switch( m_sConfigData.nRadio_RGBColorDepth )
	{
		case VAL_CONFIGDLG_RADIO_RGBCD_COLOR:
			m_btnRadioCDRColor.SetCheck(1);
			m_btnRadioCDRGray.SetCheck(0);
			m_btnRadioCDRBW.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_RGBCD_GRAY:
			m_btnRadioCDRColor.SetCheck(0);
			m_btnRadioCDRGray.SetCheck(1);
			m_btnRadioCDRBW.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_RGBCD_BW:
			m_btnRadioCDRColor.SetCheck(0);
			m_btnRadioCDRGray.SetCheck(0);
			m_btnRadioCDRBW.SetCheck(1);
			break;
		default:
			break;
	}
	switch( m_sConfigData.nRadio_IRColorDepth )
	{
		case VAL_CONFIGDLG_RADIO_IRCD_GRAY:
			m_btnRadioCDIGray.SetCheck(1);
			m_btnRadioCDIBW.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_IRCD_BW:
			m_btnRadioCDIGray.SetCheck(0);
			m_btnRadioCDIBW.SetCheck(1);
			break;
		default:
			break;
	}

	m_btnCheckSCSave.SetCheck( m_sConfigData.nCheck_Scan_SaveFile );
	m_cmbResolution.SetCurSel( m_sConfigData.nCombo_Resolution );

	////////////////
	//// Step 3 ////
	////////////////

	switch( m_sConfigData.nRadio_MICRFont )
	{
		case VAL_CONFIGDLG_RADIO_MF_E13B:
			m_btnRadioMFE13B.SetCheck(1);
			m_btnRadioMFCMC7.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_MF_CMC7:
			m_btnRadioMFE13B.SetCheck(0);
			m_btnRadioMFCMC7.SetCheck(1);
			break;
		default:
			break;
	}

	m_btnCheckMIClearSpace.SetCheck( m_sConfigData.nCheck_MICR_ClearSpace );
	m_btnCheckMISaveFile.SetCheck( m_sConfigData.nCheck_MICR_SaveFile );

	////////////////
	//// Step 4 ////
	////////////////

	switch( m_sConfigData.nRadio_PrintType )
	{
		case VAL_CONFIGDLG_RADIO_PT_PHYSICAL:
			m_btnRadioPTPhysical.SetCheck(1);
			m_btnRadioPTElectronic.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_PT_ELECTRONIC:
			m_btnRadioPTPhysical.SetCheck(0);
			m_btnRadioPTElectronic.SetCheck(1);
			break;
		default:
			break;
	}

	switch( m_sConfigData.nRadio_PrintMode )
	{
		case VAL_CONFIGDLG_RADIO_PM_HIGHSPEEDMODE:
			m_btnRadioPMHighSpeedMode.SetCheck(1);
			m_btnRadioPMDataWaitingMode.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_PM_DATAWAITINGMODE:
			m_btnRadioPMHighSpeedMode.SetCheck(0);
			m_btnRadioPMDataWaitingMode.SetCheck(1);
			break;
		default:
			break;
	}

	m_btnCheckENPrintText.SetCheck( m_sConfigData.nCheck_Endorsement_PrintText );
	m_btnCheckENPrintImage.SetCheck( m_sConfigData.nCheck_Endorsement_PrintImage );
	m_btnCheckENPrnDataUnreceiveCancel.SetCheck( m_sConfigData.nCheck_Endorsement_PrnDataUnreceiveCancel );
}

void CConfigureDlg::GetControlData(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ScanningMedia = VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
	}
	else if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ScanningMedia = VAL_CONFIGDLG_RADIO_SM_CARD;
	}

	if( m_btnRadioICRGB.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ImageChannel = VAL_CONFIGDLG_RADIO_IC_RGB;
	}
	else if( m_btnRadioICIR.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ImageChannel = VAL_CONFIGDLG_RADIO_IC_IR;
	}
	else if( m_btnRadioICRGBIR.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ImageChannel = VAL_CONFIGDLG_RADIO_IC_RGBIR;
	}

	if( m_btnRadioCDRColor.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
	}
	else if( m_btnRadioCDRGray.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_GRAY;
	}
	else if( m_btnRadioCDRBW.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_BW;
	}

	if( m_btnRadioCDIGray.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_IRColorDepth = VAL_CONFIGDLG_RADIO_IRCD_GRAY;
	}
	else if( m_btnRadioCDIBW.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_IRColorDepth = VAL_CONFIGDLG_RADIO_IRCD_BW;
	}

	m_sConfigData.nCheck_Scan_SaveFile = m_btnCheckSCSave.GetCheck();
	m_sConfigData.nCombo_Resolution = GetValueResolutionCombobox();

	////////////////
	//// Step 3 ////
	////////////////

	if( m_btnRadioMFE13B.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_MICRFont = VAL_CONFIGDLG_RADIO_MF_E13B;
	}
	else if( m_btnRadioMFCMC7.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_MICRFont = VAL_CONFIGDLG_RADIO_MF_CMC7;
	}

	m_sConfigData.nCheck_MICR_ClearSpace	= m_btnCheckMIClearSpace.GetCheck();
	m_sConfigData.nCheck_MICR_SaveFile		= m_btnCheckMISaveFile.GetCheck();

	////////////////
	//// Step 4 ////
	////////////////

	if( m_btnRadioPTPhysical.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_PrintType = VAL_CONFIGDLG_RADIO_PT_PHYSICAL;
	}
	else if( m_btnRadioPTElectronic.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_PrintType = VAL_CONFIGDLG_RADIO_PT_ELECTRONIC;
	}
	
	if( m_btnRadioPMHighSpeedMode.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_PrintMode = VAL_CONFIGDLG_RADIO_PM_HIGHSPEEDMODE;
	}
	else if( m_btnRadioPMDataWaitingMode.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_PrintMode = VAL_CONFIGDLG_RADIO_PM_DATAWAITINGMODE;
	}

	m_sConfigData.nCheck_Endorsement_PrintText				= m_btnCheckENPrintText.GetCheck();
	m_sConfigData.nCheck_Endorsement_PrintImage				= m_btnCheckENPrintImage.GetCheck();
	m_sConfigData.nCheck_Endorsement_PrnDataUnreceiveCancel	= m_btnCheckENPrnDataUnreceiveCancel.GetCheck();
}

void CConfigureDlg::UpdateControls(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	// ImageChannel
	if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioICRGBIR.EnableWindow( false );
		
		if(m_btnRadioICRGBIR.GetCheck() == 1)
		{
			m_btnRadioICIR.SetCheck(1);
			m_btnRadioICRGBIR.SetCheck(0);
		}
	}
	else if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_btnRadioICRGBIR.EnableWindow( true );
	}

	// RGB ColorDepth Color
	if( m_btnRadioICIR.GetCheck() == 1 )
	{
		m_btnRadioCDRColor.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDRColor.EnableWindow( TRUE );
	}

	// RGB ColorDepth Gray
	if( m_btnRadioICIR.GetCheck() == 1 )
	{
		m_btnRadioCDRGray.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDRGray.EnableWindow( TRUE );
	}

	// RGB ColorDepth B/W
	if( m_btnRadioICIR.GetCheck() == 1 || m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioCDRBW.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDRBW.EnableWindow( TRUE );
	}

	// IR ColorDepth Gray
	if( m_btnRadioICRGB.GetCheck() == 1 )
	{
		m_btnRadioCDIGray.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDIGray.EnableWindow( TRUE );
	}

	// IR ColorDepth B/W
	if( m_btnRadioICRGB.GetCheck() == 1 || m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioCDIBW.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDIBW.EnableWindow( TRUE );
	}

	if( m_btnRadioCDRBW.GetCheck() == 1 && m_btnRadioCDRGray.IsWindowEnabled() && !m_btnRadioCDRBW.IsWindowEnabled() )
	{
		m_btnRadioCDRColor.SetCheck(0);
		m_btnRadioCDRGray.SetCheck(1);
		m_btnRadioCDRBW.SetCheck(0);
	}
	if( m_btnRadioCDIBW.GetCheck() == 1 && m_btnRadioCDIGray.IsWindowEnabled() && !m_btnRadioCDIBW.IsWindowEnabled() )
	{
		m_btnRadioCDIGray.SetCheck(1);
		m_btnRadioCDIBW.SetCheck(0);
	}

	// Updating resolution options for scanning unit
	CString strResolution;
	m_cmbResolution.GetLBText( m_cmbResolution.GetCurSel(), strResolution );
	if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_cmbResolution.ResetContent();
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_300300 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_240240 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_200200 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_120120 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_100100 );
		if( SetIndexResolutionCombobox( strResolution ) != true )
		{
			// If selected option is disabled, 300*300 is set
			m_cmbResolution.SetCurSel(0);
		}
	}
	else if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_cmbResolution.ResetContent();
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_600600 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_300300 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_200200 );
		if( SetIndexResolutionCombobox( strResolution ) != true )
		{
			// If selected option is disabled, 200*200 is set
			m_cmbResolution.SetCurSel(2);
		}
	}

	////////////////
	//// Step 3 ////
	////////////////

	if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioMFE13B.EnableWindow( false );
		m_btnRadioMFCMC7.EnableWindow( false );
		m_btnCheckMIClearSpace.EnableWindow( false );
		m_btnCheckMISaveFile.EnableWindow( false );
	}
	else if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_btnRadioMFE13B.EnableWindow( true );
		m_btnRadioMFCMC7.EnableWindow( true );
		m_btnCheckMIClearSpace.EnableWindow( true );
		m_btnCheckMISaveFile.EnableWindow( true );
	}

	////////////////
	//// Step 4 ////
	////////////////

	if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioPTPhysical.EnableWindow( false );
		m_btnRadioPTElectronic.EnableWindow( false );
		m_btnRadioPMHighSpeedMode.EnableWindow( false );
		m_btnRadioPMDataWaitingMode.EnableWindow( false );
		m_btnCheckENPrintText.EnableWindow( false );
		m_btnCheckENPrintImage.EnableWindow( false );
		m_btnCheckENPrnDataUnreceiveCancel.EnableWindow( false );
	}
	else
	{
		m_btnRadioPTPhysical.EnableWindow( true );
		m_btnRadioPTElectronic.EnableWindow( true );
		m_btnCheckENPrintText.EnableWindow( true );
		m_btnCheckENPrintImage.EnableWindow( true );
		m_btnRadioPMHighSpeedMode.EnableWindow( true );
		m_btnRadioPMDataWaitingMode.EnableWindow( true );
		m_btnCheckENPrnDataUnreceiveCancel.EnableWindow( true );
	}

	if( m_btnRadioPTPhysical.GetCheck() == 1 && m_btnRadioPTPhysical.IsWindowEnabled() )
	{
		m_btnRadioPMHighSpeedMode.EnableWindow( true );
		m_btnRadioPMDataWaitingMode.EnableWindow( true );
	}
	else
	{
		m_btnRadioPMHighSpeedMode.EnableWindow( false );
		m_btnRadioPMDataWaitingMode.EnableWindow( false );
	}


	if( m_btnRadioPMHighSpeedMode.GetCheck() == 1 && m_btnRadioPMHighSpeedMode.IsWindowEnabled() )
	{
		m_btnCheckENPrnDataUnreceiveCancel.EnableWindow( true );
	}
	else
	{
		m_btnCheckENPrnDataUnreceiveCancel.EnableWindow( false );
	}
}

////////////////
//// Step 2 ////
////////////////

void CConfigureDlg::OnBnClickedOk(void)
{
	GetControlData();
	OnOK();
}

void CConfigureDlg::OnBnClickedCancel(void)
{
	OnCancel();
}

void CConfigureDlg::OnChangeRadioScanningMedia(void)
{
	UpdateControls();
}

void CConfigureDlg::OnChangeRadioImageChannel(void)
{
	UpdateControls();
}

bool CConfigureDlg::SetIndexResolutionCombobox( LPCTSTR lpszResolution )
{
	CString strResolution;
	int nCnt = 0;
	int nSize = m_cmbResolution.GetCount();
	
	if( lpszResolution != NULL )
	{
		for( nCnt = 0 ; nCnt < nSize ; nCnt++ )
		{
			m_cmbResolution.GetLBText( nCnt, strResolution );
			if( strResolution.CompareNoCase( lpszResolution ) == 0 )
			{
				m_cmbResolution.SetCurSel(nCnt);
				return true;
			}
		}
	}

	m_cmbResolution.SetCurSel(0);
	return false;
}

bool CConfigureDlg::SetIndexResolutionCombobox( int nResolution )
{
	CString strResolution;
	int nCnt = 0;
	int nSize = m_cmbResolution.GetCount();
	int nValue = 0;
	
	for( nCnt = 0 ; nCnt < nSize ; nCnt++ )
	{
		m_cmbResolution.GetLBText( nCnt, strResolution );
		if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_600600 ) == 0 )
		{
			nValue = VAL_CONFIGDLG_COMBO_RE_600600;
		}
		if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_300300 ) == 0 )
		{
			nValue = VAL_CONFIGDLG_COMBO_RE_300300;
		}
		if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_240240 ) == 0 )
		{
			nValue = VAL_CONFIGDLG_COMBO_RE_240240;
		}
		if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_200200 ) == 0 )
		{
			nValue = VAL_CONFIGDLG_COMBO_RE_200200;
		}
		if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_120120 ) == 0 )
		{
			nValue = VAL_CONFIGDLG_COMBO_RE_120120;
		}
		if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_100100 ) == 0 )
		{
			nValue = VAL_CONFIGDLG_COMBO_RE_100100;
		}

		if( nValue == nResolution )
		{
			m_cmbResolution.SetCurSel(nCnt);
			return true;
		}
	}

	m_cmbResolution.SetCurSel(0);
	return false;
}

int CConfigureDlg::GetValueResolutionCombobox(void)
{
	CString strResolution;
	m_cmbResolution.GetLBText( m_cmbResolution.GetCurSel(), strResolution );

	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_600600 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_600600;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_300300 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_300300;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_240240 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_240240;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_200200 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_200200;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_120120 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_120120;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_100100 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_100100;
	}

	return -1;
}

////////////////
//// Step 3 ////
////////////////

// None.

////////////////
//// Step 4 ////
////////////////

void CConfigureDlg::OnChangeRadioPrintType(void)
{
	UpdateControls();
}


void CConfigureDlg::OnChangeRadioPrintMode(void)
{
	UpdateControls();
}

