#pragma once
#include "afxwin.h"


// CConfigureDlg Dialog

class CConfigureDlg : public CDialog
{
	DECLARE_DYNAMIC(CConfigureDlg)

public:
	CConfigureDlg(CWnd* pParent = NULL);   // Standard constructor
	virtual ~CConfigureDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_DIALOG_CONFIG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Support

public:
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnInitDialog(void);
	// Step 2
	afx_msg void OnBnClickedOk(void);
	afx_msg void OnBnClickedCancel(void);
	afx_msg void OnChangeRadioScanningMedia(void);
	afx_msg void OnChangeRadioImageChannel(void);
	// Step 3
	// None.
	// Step 7
	afx_msg void OnChangeCheckIqaDetect(void);
	afx_msg void OnChangeRadioActivationMode(void);
	afx_msg void OnCbnSelchangeComboWaterfallMode(void);
	afx_msg void OnChangeRadioRgbColorDepth(void);

// Control
protected:
	// Step 2
	CButton	m_btnOK;
	CButton	m_btnCancel;

	CStatic	m_stGroupScanning;
	CStatic	m_stGroupScanningMedia;
	CStatic	m_stGroupImageChannel;
	CStatic	m_stGroupRGBColorDepth;
	CStatic	m_stGroupIRColorDepth;

	CStatic		m_stResolution;
	CComboBox	m_cmbResolution;

	CButton	m_btnRadioSMCheckPaper;
	CButton	m_btnRadioSMCard;
	CButton	m_btnRadioICRGB;
	CButton	m_btnRadioICIR;
	CButton	m_btnRadioICRGBIR;
	CButton	m_btnRadioCDRColor;
	CButton	m_btnRadioCDRGray;
	CButton	m_btnRadioCDRBW;
	CButton	m_btnRadioCDIGray;
	CButton	m_btnRadioCDIBW;

	CButton	m_btnCheckSCSave;

	// Step 3
	CStatic	m_stGroupMICR;
	CStatic	m_stGroupMICRFont;

	CButton	m_btnRadioMFE13B;
	CButton	m_btnRadioMFCMC7;

	CButton	m_btnCheckMIClearSpace;
	CButton	m_btnCheckMISaveFile;

	// Step 7
	CStatic m_stGroupWaterfall;
	CStatic m_stGroupIQA;
	CStatic m_stGroupActivation;
	CStatic m_stGroupACActivation;

	CStatic m_stWaterfall;
	CStatic m_stColorDepth;
	CStatic m_stEjectPocket;

	CButton m_btnRadioAMHighSpeed;
	CButton m_btnRadioAMConfirmation;

	CButton m_btnCheckIQDetect;
	CButton m_btnCheckIQCancel;
	CButton m_btnCheckIQUnderSize;
	CButton m_btnCheckIQOverSize;
	CButton m_btnCheckIQMinCompressed;
	CButton m_btnCheckIQMaxCompressed;
	CButton m_btnCheckIQFrontRearMismatch;
	CButton m_btnCheckIQTooLight;
	CButton m_btnCheckIQTooDark;
	CButton m_btnCheckIQHorizontalStreaks;
	CButton m_btnCheckIQSpotNoise;
	CButton m_btnCheckIQOutOfFocus;
	CButton m_btnCheckIQDocCorners;
	CButton m_btnCheckIQDocEdges;
	CButton m_btnCheckIQFramingError;
	CButton m_btnCheckIQSkew;
	CButton m_btnCheckIQCarbonStrip;
	CButton m_btnCheckIQPiggyback;
	CButton m_btnCheckACOnePiece;

	CComboBox m_cmbWaterfall;
	CComboBox m_cmbColorDepth;
	CComboBox m_cmbEjectPocket;

// Function
public:
	// Step 2
	void SetConfigData( CONFIGDATA sConfigData );
	void GetConfigData( LPCONFIGDATA psConfigData );

protected:
	// Step 2
	void LoadResourceString(void);
	void SetControlData(void);
	void GetControlData(void);
	void UpdateControls(void);
	bool SetIndexResolutionCombobox( LPCTSTR lpszResolution );
	bool SetIndexResolutionCombobox( int nResolution );
	int GetValueResolutionCombobox(void);
	// Step 7
	int GetValueWaterfallModeCombobox(void);
	int GetValueIQAColorDepthCombobox(void);
	int GetValueIQAEjectPocketCombobox(void);

// Value
private:
	// Step 2
	CONFIGDATA	m_sConfigData;
};
