#if !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81)
#define SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81

#pragma once

// Step 1
#include "Scan.h"
#include "Micr.h"
#include "Option.h"

typedef int(__stdcall * PROCESS_ERROR_BACK_FUNC)(short);

// Step 2
#include "ScanParam.h"
#include "Image_1.h"

typedef int(__stdcall * COMPLATE_BACK_FUNC)(int);
typedef int(__stdcall * MICR_IMAGE_BACK_FUNC)(void);

#define EXEC_SCAN_CHECK	0
#define EXEC_SCAN_CARD	1

// Step 3
#include "MicrParam.h"

// Step 8
#include "Barcode.h"
#include "BarcodeParam.h"
#include "OptionParam.h"
#include "Info.h"

typedef int(__stdcall * BARCODE_BACK_FUNC)(void);
typedef int(__stdcall * DEVICE_STATUS_BACK_FUNC)(void);
typedef int(__stdcall * INK_STATUS_BACK_FUNC)(void);

class CApp
{
private:
	// Step 1
	CProperty_1								m_CCProperty;
	CScan									m_CCScan;
	CMicr									m_CCMicr;
	COption									m_CCOption;
	PROCESS_ERROR_BACK_FUNC					m_pFuncProcessErrorCB;

	DLL_BiOpenMonPrinter					BiOpenMonPrinter;
	DLL_BiCloseMonPrinter					BiCloseMonPrinter;
	DLL_BiSCNMICRSetStatusBackFunction		BiSCNMICRSetStatusBackFunction;
	DLL_BiSCNMICRCancelStatusBack			BiSCNMICRCancelStatusBack;
	DLL_BiCancelError						BiCancelError;
	DLL_BiGetStatus							BiGetStatus;
	// Step 8
	DLL_BiSetStatusBackFunction				BiSetStatusBackFunction;
	DLL_BiSetInkStatusBackFunction			BiSetInkStatusBackFunction;
	DLL_BiCancelStatusBack					BiCancelStatusBack;
	DLL_BiCancelInkStatusBack				BiCancelInkStatusBack;

	// Step 2
	CImage_1								m_CCImage;
	BYTE									m_byExecType;
	MICR_IMAGE_BACK_FUNC					m_pFuncImageCB;

	// Step 3
	MICR_IMAGE_BACK_FUNC					m_pFuncMicrCB;

	// Step 8
	CBarcode								m_CCBarcode;
	CInfo									m_CCInfo;
	BARCODE_BACK_FUNC						m_pFuncBarcodeCB;
	DEVICE_STATUS_BACK_FUNC					m_pFuncDeviceStatusCB;
	INK_STATUS_BACK_FUNC					m_pFuncInkStatusCB;

public:
	// Step 1
	CApp(void);
	virtual ~CApp(void);

	int		InitDevice(void);
	int		ExitDevice(void);
	int		CancelError(void);
	int		CancelScan(void);
	int		ScanCheck(void);
	int		GetDeviceStatus(LPDWORD lpStatus);
	void	SetProcessErrorCallback(PROCESS_ERROR_BACK_FUNC pProcessErrorCB);

	// Step 2
	void	SetImageCallback(MICR_IMAGE_BACK_FUNC pImageCB);
	void	SetScanParam(CScanParam* pCCScanParam);
	void	GetScanParam(CScanParam* pCCScanParam);
	int		GetScanImage(CImageResult* pCCImageResult);
	int		ScanCard(void);

	// Step 3
	void	SetMicrCallback(MICR_IMAGE_BACK_FUNC pMicrCB);
	void	SetMicrParam(CMicrParam* pCCMicrParam);
	void	GetMicrParam(CMicrParam* pCCMicrParam);
	int		GetMicr(CMicrResult* pCCMicrResult);
	int		CleaningMicr(void);

	// Step 8
	void	SetBarcodeCallback(BARCODE_BACK_FUNC pBarcodeCB);
	void	SetBarcodeParam(CBarcodeParam* pCCBarcodeParam);
	void	GetBarcodeParam(CBarcodeParam* pCCBarcodeParam);
	int		GetBarcode(CBarcodeResult* pCCBarcodeResult);
	void	SetOptionParam(COptionParam* pCCOptionParam);
	void	GetOptionParam(COptionParam* pCCOptionParam);
	void	SetDeviceStatusCallback(DEVICE_STATUS_BACK_FUNC pDeviceStatusCB);
	int		GetDeviceStatusFunction(CDeviceStatus* pCCDeviceStatus);
	void	SetInkStatusCallback(INK_STATUS_BACK_FUNC pInkStatusCB);
	int		GetInkStatusFunction(CInkStatus* pCCInkStatus);
	int		GetMaintenanceCounter(CMaintenanceCounter* pCCMaintenanceCounter);
	int		GetDeviceInfo(CDeviceInfo* pCCDeviceInfo);

private:
	// Step 1
	void		GetAPIProcAddress(void);
	static int	CALLBACK cbScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
	int			ScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
	// Step 8
	static int	CALLBACK cbStatus(DWORD dwStatus);
	int			Status(DWORD dwStatus);
	static int	CALLBACK cbInkStatus(WORD wStatus);
	int			InkStatus(WORD wStatus);
};

#endif  /* !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81) */
