#pragma once
#include "afxwin.h"


// CConfigureDlg Dialog

class CConfigureDlg : public CDialog
{
	DECLARE_DYNAMIC(CConfigureDlg)

public:
	CConfigureDlg(CWnd* pParent = NULL);   // Standard constructor
	virtual ~CConfigureDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_DIALOG_CONFIG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Support

public:
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnInitDialog(void);
	// Step 2
	afx_msg void OnBnClickedOk(void);
	afx_msg void OnBnClickedCancel(void);
	afx_msg void OnChangeRadioScanningMedia(void);
	afx_msg void OnChangeRadioImageChannel(void);
	// Step 3
	// None.
	// Step 8
	afx_msg void OnChangeCheckPaperInsertionDetect(void);
	afx_msg void OnChangeCheckNoiseDetect(void);
	afx_msg void OnChangeCheckDoubleFeedDetect(void);
	afx_msg void OnChangeCheckBadDataDetect(void);
	afx_msg void OnChangeCheckNoDataDetect(void);
	afx_msg void OnChangeCheckBarcodeDetect(void);

// Control
protected:
	// Step 2
	CButton	m_btnOK;
	CButton	m_btnCancel;

	CStatic	m_stGroupScanning;
	CStatic	m_stGroupScanningMedia;
	CStatic	m_stGroupImageChannel;
	CStatic	m_stGroupRGBColorDepth;
	CStatic	m_stGroupIRColorDepth;

	CStatic		m_stResolution;
	CComboBox	m_cmbResolution;

	CButton	m_btnRadioSMCheckPaper;
	CButton	m_btnRadioSMCard;
	CButton	m_btnRadioICRGB;
	CButton	m_btnRadioICIR;
	CButton	m_btnRadioICRGBIR;
	CButton	m_btnRadioCDRColor;
	CButton	m_btnRadioCDRGray;
	CButton	m_btnRadioCDRBW;
	CButton	m_btnRadioCDIGray;
	CButton	m_btnRadioCDIBW;

	CButton	m_btnCheckSCSave;

	// Step 3
	CStatic	m_stGroupMICR;
	CStatic	m_stGroupMICRFont;

	CButton	m_btnRadioMFE13B;
	CButton	m_btnRadioMFCMC7;

	CButton	m_btnCheckMIClearSpace;
	CButton	m_btnCheckMISaveFile;

	// Step 8
	CStatic m_stGroupError;
	CStatic m_stGroupPaperInsertion;
	CStatic m_stGroupNoise;
	CStatic m_stGroupDoubleFeed;
	CStatic m_stGroupBadData;
	CStatic m_stGroupNoData;
	CStatic m_stGroupBarcode;

	CButton m_btnCheckPIDetect;
	CButton m_btnCheckPICancel;
	CButton m_btnCheckNODetect;
	CButton m_btnCheckNOCancel;
	CButton m_btnCheckDFDetect;
	CButton m_btnCheckDFCancel;
	CButton m_btnCheckBDDetect;
	CButton m_btnCheckBDCancel;
	CButton m_btnCheckNDDetect;
	CButton m_btnCheckNDCancel;
	CButton m_btnCheckBADetect;
	CButton m_btnCheckBACancel;

	CStatic		m_stPIEjectPocket;
	CComboBox	m_cmbPIEjectPocket;
	CStatic		m_stNOEjectPocket;
	CComboBox	m_cmbNOEjectPocket;
	CStatic		m_stDFEjectPocket;
	CComboBox	m_cmbDFEjectPocket;
	CStatic		m_stBDEjectPocket;
	CComboBox	m_cmbBDEjectPocket;
	CStatic		m_stNDEjectPocket;
	CComboBox	m_cmbNDEjectPocket;
	CStatic		m_stBAEjectPocket;
	CComboBox	m_cmbBAEjectPocket;

// Function
public:
	// Step 2
	void SetConfigData( CONFIGDATA sConfigData );
	void GetConfigData( LPCONFIGDATA psConfigData );

protected:
	// Step 2
	void LoadResourceString(void);
	void SetControlData(void);
	void GetControlData(void);
	void UpdateControls(void);
	bool SetIndexResolutionCombobox( LPCTSTR lpszResolution );
	bool SetIndexResolutionCombobox( int nResolution );
	int GetValueResolutionCombobox(void);
	// Step 8
	int GetValuePIEjectPocketCombobox(void);
	int GetValueNOEjectPocketCombobox(void);
	int GetValueDFEjectPocketCombobox(void);
	int GetValueBDEjectPocketCombobox(void);
	int GetValueNDEjectPocketCombobox(void);
	int GetValueBAEjectPocketCombobox(void);

// Value
private:
	// Step 2
	CONFIGDATA	m_sConfigData;
};
