#include "stdafx.h"
#include "Info.h"

CInfo::CInfo(void)
{
	m_pCProperty = NULL;
}

CInfo::~CInfo(void)
{
}

int CInfo::Init(CProperty_1* pCCProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pCCProperty;

	GetAPIProcAddress();

	return nResult;
}

// Get device status
int CInfo::GetDeviceStatusFunction(CDeviceStatus *pCCDeviceStatus)
{
	int nResult		= SUCCESS;
	DWORD dwStatus	= 0;

	if(pCCDeviceStatus == NULL)
	{
		return -1;
	}

	nResult = BiGetStatus(m_pCProperty->GetHandle(), &dwStatus);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	//NO_RESPONSE
	if((dwStatus & ASB_NO_RESPONSE) == ASB_NO_RESPONSE)
	{
		pCCDeviceStatus->SetNoResponse(true);
	}
	else
	{
		pCCDeviceStatus->SetNoResponse(false);
	}

	//OFF_LINE
	if((dwStatus & ASB_OFF_LINE) == ASB_OFF_LINE)
	{
		pCCDeviceStatus->SetOffLine(true);
	}
	else
	{
		pCCDeviceStatus->SetOffLine(false);
	}

	//COVER_OPEN
	if((dwStatus & ASB_COVER_OPEN) == ASB_COVER_OPEN)
	{
		pCCDeviceStatus->SetCoverOpen(true);
	}
	else
	{
		pCCDeviceStatus->SetCoverOpen(false);
	}

	//WAIT_PEPRT_EJECT
	if((dwStatus & ASB_WAIT_PEPRT_EJECT) == ASB_WAIT_PEPRT_EJECT)
	{
		pCCDeviceStatus->SetWaitPaperEject(true);
	}
	else
	{
		pCCDeviceStatus->SetWaitPaperEject(false);
	}

	//MECHANICAL_ERR
	if((dwStatus & ASB_MECHANICAL_ERR) == ASB_MECHANICAL_ERR)
	{
		pCCDeviceStatus->SetMechanicalError(true);
	}
	else
	{
		pCCDeviceStatus->SetMechanicalError(false);
	}

	//UNRECOVER_ERR
	if((dwStatus & ASB_UNRECOVER_ERR) == ASB_UNRECOVER_ERR)
	{
		pCCDeviceStatus->SetUnrecoverError(true);
	}
	else
	{
		pCCDeviceStatus->SetUnrecoverError(false);
	}

	//PAPER_INTERMEDIATE
	if((dwStatus & ASB_PAPER_INTERMEDIATE) == ASB_PAPER_INTERMEDIATE)
	{
		pCCDeviceStatus->SetPaperInsermadiate(true);
	}
	else
	{
		pCCDeviceStatus->SetPaperInsermadiate(false);
	}

	//RECEIPT_NEAR_END
	if((dwStatus & ASB_RECEIPT_NEAR_END) == ASB_RECEIPT_NEAR_END)
	{
		// S9000 only
		pCCDeviceStatus->SetReceiptNearEnd(true);
	}
	else
	{
		pCCDeviceStatus->SetReceiptNearEnd(false);
	}

	//EJECT_SENSOR_NO_PAPER
	if((dwStatus & ASB_EJECT_SENSOR_NO_PAPER) == ASB_EJECT_SENSOR_NO_PAPER)
	{
		pCCDeviceStatus->SetEjectSensorPaper(true);
	}
	else
	{
		pCCDeviceStatus->SetEjectSensorPaper(false);
	}

	//RECEIPT_END
	if((dwStatus & ASB_RECEIPT_END) == ASB_RECEIPT_END)
	{
		// S9000 only
		pCCDeviceStatus->SetReceiptEnd(true);
	}
	else
	{
		pCCDeviceStatus->SetReceiptEnd(false);
	}

	//SLIP_PAPER_SIZE
	if((dwStatus & ASB_SLIP_PAPER_SIZE) == ASB_SLIP_PAPER_SIZE)
	{
		pCCDeviceStatus->SetSlipPaperSize(true);
	}
	else
	{
		pCCDeviceStatus->SetSlipPaperSize(false);
	}

	//ASF_PAPER
	if((dwStatus & ASB_ASF_PAPER) == ASB_ASF_PAPER)
	{
		pCCDeviceStatus->SetAsfPaper(true);
	}
	else
	{
		pCCDeviceStatus->SetAsfPaper(false);
	}

	//WAIT_INSERT
	if((dwStatus & ASB_WAIT_INSERT) == ASB_WAIT_INSERT)
	{
		pCCDeviceStatus->SetWaitInsert(true);
	}
	else
	{
		pCCDeviceStatus->SetWaitInsert(false);
	}

	//MAIN_POCKET_NEAR_FULL
	if((dwStatus & ASB_MAIN_POCKET_NEAR_FULL) == ASB_MAIN_POCKET_NEAR_FULL)
	{
		pCCDeviceStatus->SetMainPocketNearFull(true);
	}
	else
	{
		pCCDeviceStatus->SetMainPocketNearFull(false);
	}

	//SUB_POCKET_NEAR_FULL
	if((dwStatus & ASB_SUB_POCKET_NEAR_FULL) == ASB_SUB_POCKET_NEAR_FULL)
	{
		pCCDeviceStatus->SetSubPocketNearFull(true);
	}
	else
	{
		pCCDeviceStatus->SetSubPocketNearFull(false);
	}

	return nResult;
}

// Get ink status
int CInfo::GetInkStatusFunction(CInkStatus *pCCInkStatus)
{
	int		nResult		= SUCCESS;
	WORD	wStatus	= 0;

	if(pCCInkStatus == NULL)
	{
		return -1;
	}

	nResult = BiGetInkStatus(m_pCProperty->GetHandle(), &wStatus);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	if((wStatus & INK_ASB_NEAR_END) == INK_ASB_NEAR_END)
	{
		pCCInkStatus->SetInkNearEnd(true);
	}
	else
	{
		pCCInkStatus->SetInkNearEnd(false);
	}

	if((wStatus & INK_ASB_END) == INK_ASB_END)
	{
		pCCInkStatus->SetInkEnd(true);
	}
	else
	{
		pCCInkStatus->SetInkEnd(false);
	}

	if((wStatus & INK_ASB_NO_CARTRIDGE) == INK_ASB_NO_CARTRIDGE)
	{
		pCCInkStatus->SetInkNoCartridge(true);
	}
	else
	{
		pCCInkStatus->SetInkNoCartridge(false);
	}

	if((wStatus & INK_ASB_CLEANING) == INK_ASB_CLEANING)
	{
		pCCInkStatus->SetInkCleaning(true);
	}
	else
	{
		pCCInkStatus->SetInkCleaning(false);
	}

	return nResult;
}

// Get device information
int CInfo::GetDeviceInfoFunction(CDeviceInfo *pCCDeviceInfo)
{
	int		nResult								= SUCCESS;
	BYTE	DeviceSize							= MAX_DEVICE_INFO_SIZE;
	BYTE	DeviceInfo[MAX_DEVICE_INFO_SIZE]	= {0};

	if(pCCDeviceInfo == NULL)
	{
		return -1;
	}

	// Get device name
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_DEVICE_NAME, &DeviceSize, DeviceInfo);
	if(nResult == SUCCESS)
	{
		pCCDeviceInfo->SetDeviceName(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get manufacturer
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_MANUFACTURE, &DeviceSize, DeviceInfo);
	if(nResult == SUCCESS)
	{
		pCCDeviceInfo->SetManufacture(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get firmware version
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_FIRM_VERSION, &DeviceSize, DeviceInfo);
	if(nResult == SUCCESS)
	{
		pCCDeviceInfo->SetFirmVersion(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get serial number
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_SERIAL_NUMBER, &DeviceSize, DeviceInfo);
	if(nResult == SUCCESS)
	{
		pCCDeviceInfo->SetSerialNumber(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get number of pockets and document processing speed
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_SPEED_POCKET, &DeviceSize, DeviceInfo);
	if(nResult == SUCCESS)
	{
		pCCDeviceInfo->SetTypeIdB(DeviceInfo);
	}
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);


	return nResult;
}

// Get maintenance counter
int CInfo::GetMaintenanceCounterFunction(CMaintenanceCounter *pCCMaintenanceCounter)
{
	int  nResult	= SUCCESS;
	DWORD dwCounter	= 0;

	if(pCCMaintenanceCounter == NULL)
	{
		return -1;
	}

	// Lines fed (Roll paper)
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_LINE_FEEDS, &dwCounter);
	if(nResult == SUCCESS)
	{
		// S9000
		pCCMaintenanceCounter->SetLineFeeds(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pCCMaintenanceCounter->SetLineFeeds(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Lines fed (Thermal head)
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_LINE_FEEDS, &dwCounter);
	if(nResult == SUCCESS)
	{
		// S9000
		pCCMaintenanceCounter->SetHeadLineFeeds(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pCCMaintenanceCounter->SetHeadLineFeeds(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Head shot A
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_SHOT_A, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetHeadShotA(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Head shot B
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_SHOT_B, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetHeadShotB(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Thermal head energization
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_ENERGIZATION, &dwCounter);
	if(nResult == SUCCESS)
	{
		// S9000
		pCCMaintenanceCounter->SetHeadEnergization(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pCCMaintenanceCounter->SetHeadEnergization(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Pump operations
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_PUMP_OPERATION, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetPumpOperation(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Auto cutter drive
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_AUTO_CUTTER, &dwCounter);
	if(nResult == SUCCESS)
	{
		// S9000
		pCCMaintenanceCounter->SetAutoCutter(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pCCMaintenanceCounter->SetAutoCutter(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Check paper fed
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_ASF_SENDING_OFF, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetAsfSendingOff(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Check paper scanned
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_SCANNED_CHECK, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetImageScannedCheckPaper(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Card scanned
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_SCANNED_CARD, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetImageScannedCard(dwCounter);
	}
	else
	{
		return nResult;
	}

	// MICR reads
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_MICR_READS, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetMicrReads(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Pocket switch
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_POCKET_SELECT, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetPocketSelect(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Hopper open/close
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HOPPER, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetHopper(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Duration of product operation
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_DEVICE_OPERATION_TIME, &dwCounter);
	if(nResult == SUCCESS)
	{
		pCCMaintenanceCounter->SetDeviceOperationTime(dwCounter);
	}
	else
	{
		return nResult;
	}

	return nResult;
}

// Get functions of the API
void CInfo::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiGetCounter		= (DLL_BiGetCounter)		GetProcAddress(hLibrary, "BiGetCounter");
	BiGetStatus			= (DLL_BiGetStatus)			GetProcAddress(hLibrary, "BiGetStatus");
	BiGetInkStatus		= (DLL_BiGetInkStatus)		GetProcAddress(hLibrary, "BiGetInkStatus");
	BiGetPrnCapability	= (DLL_BiGetPrnCapability)	GetProcAddress(hLibrary, "BiGetPrnCapability");
}
