VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Process"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private m_pCProperty As Property_1
Private m_mfProcess01 As MF_PROCESS01

Private Sub Class_Initialize()

    If (m_pCProperty Is Nothing) Then
        Set m_pCProperty = New Property_1
    End If

End Sub

Public Sub SetProperty(ByRef pCProperty As Property_1)

    Set m_pCProperty = pCProperty

End Sub

'// Set MF_PROCESS01 structure
Public Function SetProcessSetting() As Long

    Dim lResult As Long
    
    Call CopyMemory(m_mfProcess01.iSize(1), CLng(LenB(m_mfProcess01)), 4)
    Call CopyMemory(m_mfProcess01.iVersion(1), MF_PROCESS_VERSION01, 4)

    lResult = FunctionContinuouslyProcess(m_pCProperty.GetHandle(), m_mfProcess01, MF_GET_PROCESS_DEFAULT)
    If Not (lResult = SUCCESS) Then
    
        SetProcessSetting = lResult
        Exit Function
    
    End If

    m_mfProcess01.bActivationMode = m_pCProperty.GetActivation()

    '// Mis-Insertion error
    m_mfProcess01.bPaperMisInsertionErrorSelect = m_pCProperty.GetPaperMisInsertionDetect()
    If (m_pCProperty.GetPaperMisInsertionDetect() = MF_ERROR_SELECT_DETECT) Then
    
        m_mfProcess01.bPaperMisInsertionCancel = m_pCProperty.GetPaperMisInsertionCancel()
        m_mfProcess01.bPaperMisInsertionErrorEject = m_pCProperty.GetPaperMisInsertionEject()
        
    End If

    '// Noise error
    m_mfProcess01.bNoiseErrorSelect = m_pCProperty.GetNoiseDetect()
    If (m_pCProperty.GetNoiseDetect() = MF_ERROR_SELECT_DETECT) Then
    
        m_mfProcess01.bNoiseCancel = m_pCProperty.GetNoiseCancel()
        m_mfProcess01.bNoiseErrorEject = m_pCProperty.GetNoiseEject()
        
    End If

    '// Double feed error
    m_mfProcess01.bDoubleFeedErrorSelect = m_pCProperty.GetDoubleFeedDetect()
    If (m_pCProperty.GetDoubleFeedDetect() = MF_ERROR_SELECT_DETECT) Then
    
        m_mfProcess01.bDoubleFeedCancel = m_pCProperty.GetDoubleFeedCancel()
        m_mfProcess01.bDoubleFeedErrorEject = m_pCProperty.GetDoubleFeedEject()
        
    End If

    '// Bad data in MICR error
    m_mfProcess01.bBaddataErrorSelect = m_pCProperty.GetBaddataDetect()
    If (m_pCProperty.GetBaddataDetect() = MF_ERROR_SELECT_DETECT) Then
    
        m_mfProcess01.bBaddataCancel = m_pCProperty.GetBaddataCancel()
        m_mfProcess01.bBaddataErrorEject = m_pCProperty.GetBaddataEject()
        m_mfProcess01.bBaddataCount = 0
        
    End If

    '// No data in MICR magnetic waveform error
    m_mfProcess01.bNodataErrorSelect = m_pCProperty.GetNodataDetect()
    If (m_pCProperty.GetNodataDetect() = MF_ERROR_SELECT_DETECT) Then
    
        m_mfProcess01.bNodataCancel = m_pCProperty.GetNodataCancel()
        m_mfProcess01.bNodataErrorEject = m_pCProperty.GetNodataEject()
        
    End If

    '// Set endorsement printing mode
    m_mfProcess01.bEndorsePrintMode = MF_ENDORSEPRINT_MODE_DATAWAITING

    '// Print data unreceived error
    m_mfProcess01.bPrnDataUnreceiveCancel = m_pCProperty.GetPrnDataUnreceiveCancel()

    lResult = FunctionContinuouslyProcess(m_pCProperty.GetHandle(), m_mfProcess01, MF_SET_PROCESS_PARAM)
    
    Call m_pCProperty.SetMfProcess(m_mfProcess01)
    
    SetProcessSetting = lResult

End Function

'// Set Waterfall Mode
Public Function SetWaterfallMode() As Long

    Dim lResult As Long

    lResult = BiSetWaterfallMode(m_pCProperty.GetHandle(), m_pCProperty.GetWaterfall())

    SetWaterfallMode = lResult

End Function

'// Perform scanning using confirmation mode
Public Function ConfirmationFunction() As Long

    Dim lResult As Long

    lResult = BiSetBehaviorToScnResult(m_pCProperty.GetHandle(), m_pCProperty.GetConfirmationEject(), _
                                                        MF_STAMP_DISABLE, m_pCProperty.GetConfirmationCancel())

    ConfirmationFunction = lResult

End Function

